-------------------------------------------------------------------------------
-- ElvUI Chat Hover Links By Lockslap (US, Bleeding Hollow)
-- http://lockslap.com, http://wowhead-tooltips.com
-- Based on functionality in TipTac by Aezay
-------------------------------------------------------------------------------
local E, C, L, DB = unpack(ElvUI)	-- load the elvui engine
local _G = getfenv(0)
local ChatHoverLinks = CreateFrame("Frame")

local modName = ...
local hoverScripts = {}
local enabled

-- constants
local supportedHyperlinkTypes = {
	item = true,
	spell = true,
	unit = true,
	quest = true,
	enchant = true,
	achievement = true,
	instancelock = true,
	talent = true,
	glyph = true,
}

--[[ borrowed from tooltip.lua of elvui's core
hooksecurefunc("GameTooltip_SetDefaultAnchor", function(self, parent)
	if C["tooltip"].cursor == true then
		if IsAddOnLoaded("Elvui_RaidHeal") and parent ~= UIParent then 
			self:SetOwner(parent, "ANCHOR_NONE")	
		else
			self:SetOwner(parent, "ANCHOR_CURSOR")
		end
	else
		self:SetOwner(parent, "ANCHOR_NONE")
	end
	self.default = 1
end)]]

--[[ from elvui's tooltip.lua, attempt to fix compare tooltips
hooksecurefunc("GameTooltip_ShowCompareItem", function(self, shift)
	if ( not self ) then
		self = GameTooltip;
	end
	local item, link = self:GetItem();
	if ( not link ) then
		return;
	end
	
	local shoppingTooltip1, shoppingTooltip2, shoppingTooltip3 = unpack(self.shoppingTooltips);

	local item1 = nil;
	local item2 = nil;
	local item3 = nil;
	local side = "right";
	if ( shoppingTooltip1:SetHyperlinkCompareItem(link, 1, shift, self) ) then
		item1 = true;
	end
	if ( shoppingTooltip2:SetHyperlinkCompareItem(link, 2, shift, self) ) then
		item2 = true;
	end
	if ( shoppingTooltip3:SetHyperlinkCompareItem(link, 3, shift, self) ) then
		item3 = true;
	end

	-- find correct side
	local rightDist = 0;
	local leftPos = TooltipMover:GetLeft();
	local rightPos = TooltipMover:GetRight();
	if ( not rightPos ) then
		rightPos = 0;
	end
	if ( not leftPos ) then
		leftPos = 0;
	end

	rightDist = GetScreenWidth() - rightPos;

	if (leftPos and (rightDist < leftPos)) then
		side = "left";
	else
		side = "right";
	end
	
	--side = "left"

	-- see if we should slide the tooltip
	if ( self:GetAnchorType() and self:GetAnchorType() ~= "ANCHOR_PRESERVE" ) then
		local totalWidth = 0;
		if ( item1  ) then
			totalWidth = totalWidth + shoppingTooltip1:GetWidth();
		end
		if ( item2  ) then
			totalWidth = totalWidth + shoppingTooltip2:GetWidth();
		end
		if ( item3  ) then
			totalWidth = totalWidth + shoppingTooltip3:GetWidth();
		end

		if ( (side == "left") and (totalWidth > leftPos) ) then
			self:SetAnchorType(self:GetAnchorType(), (totalWidth - leftPos), 0);
		elseif ( (side == "right") and (rightPos + totalWidth) >  GetScreenWidth() ) then
			self:SetAnchorType(self:GetAnchorType(), -((rightPos + totalWidth) - GetScreenWidth()), 0);
		end
	end

	-- anchor the compare tooltips
	if ( item3 ) then
		shoppingTooltip3:SetOwner(self, "ANCHOR_NONE");
		shoppingTooltip3:ClearAllPoints();
		if ( side and side == "left" ) then
			shoppingTooltip3:Point("TOPRIGHT", self, "TOPLEFT", -2, -10);
		else
			shoppingTooltip3:Point("TOPLEFT", self, "TOPRIGHT", 2, -10);
		end
		shoppingTooltip3:SetHyperlinkCompareItem(link, 3, shift, self);
		shoppingTooltip3:Show();
	end
	
	if ( item1 ) then
		if( item3 ) then
			shoppingTooltip1:SetOwner(shoppingTooltip3, "ANCHOR_NONE");
		else
			shoppingTooltip1:SetOwner(self, "ANCHOR_NONE");
		end
		shoppingTooltip1:ClearAllPoints();
		if ( side and side == "left" ) then
			if( item3 ) then
				shoppingTooltip1:Point("TOPRIGHT", shoppingTooltip3, "TOPLEFT", -2, 0);
			else
				shoppingTooltip1:Point("TOPRIGHT", self, "TOPLEFT", -2, -10);
			end
		else
			if( item3 ) then
				shoppingTooltip1:Point("TOPLEFT", shoppingTooltip3, "TOPRIGHT", 2, 0);
			else
				shoppingTooltip1:Point("TOPLEFT", self, "TOPRIGHT", 2, -10);
			end
		end
		shoppingTooltip1:SetHyperlinkCompareItem(link, 1, shift, self);
		shoppingTooltip1:Show();

		if ( item2 ) then
			shoppingTooltip2:SetOwner(shoppingTooltip1, "ANCHOR_NONE");
			shoppingTooltip2:ClearAllPoints();
			if ( side and side == "left" ) then
				shoppingTooltip2:Point("TOPRIGHT", shoppingTooltip1, "TOPLEFT", -2, 0);
			else
				shoppingTooltip2:Point("TOPLEFT", shoppingTooltip1, "TOPRIGHT", 2, 0);
			end
			shoppingTooltip2:SetHyperlinkCompareItem(link, 2, shift, self);
			shoppingTooltip2:Show();
		end
	end
end)]]

-- replacement for when hyperlinks are hovered over
local function OnHyperlinkEnter(self, refString)
	local linkToken = refString:match("^([^:]+)")
	if supportedHyperlinkTypes[linkToken] then
		if C["tooltip"].cursor == true then
			if IsAddOnLoaded("Elvui_RaidHeal") then
				GameTooltip:SetOwner(self, "ANCHOR_NONE")	
			else
				GameTooltip:SetOwner(self, "ANCHOR_CURSOR")
			end
		else
			GameTooltip:SetOwner(self, "ANCHOR_NONE")
		end
		GameTooltip:SetHyperlink(refString)
		GameTooltip:Show()
	end
end

-- leaving the hyperlink
local function OnHyperlinkLeave(self)
	GameTooltip:Hide()
end

local function setOrHookHandler(frame, script, func)
	if frame:GetScript(script) then
		frame:HookScript(script, func)
	else
		frame:SetScript(script, func)
	end
end

function ChatHoverLinks:EnableHovering()
	-- loop each chat and hook the chats onhyperlinkenter/leave events
	enabled = true
	for	i = 1, NUM_CHAT_WINDOWS do
		local chat = _G["ChatFrame" .. i]
		setOrHookHandler(chat, "OnHyperlinkEnter", OnHyperlinkEnter)
		setOrHookHandler(chat, "OnHyperlinkLeave", OnHyperlinkLeave)
	end
end

-- on enable hovering when player enters world
ChatHoverLinks:SetScript("OnEvent", function()
	if not enabled then enabled = true end
	ChatHoverLinks:EnableHovering()
	-- unregister event so it isnt duplicated
	ChatHoverLinks:UnregisterEvent("PLAYER_ENTERING_WORLD")
end)
ChatHoverLinks:RegisterEvent("PLAYER_ENTERING_WORLD")